/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-08-20 17:34
**/

#include<bits/stdc++.h>
using namespace std;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const int MAXN = 1000 + 4;
ll N, M;
bool supervised[MAXN];
vector<int> num(MAXN);


// union find - from reference (slightly adjusted)
int parent[MAXN], rnk[MAXN];
void make(int v) {
  parent[v] = v;
  num[v] = 1;
}// alt init: iota(parent, parent + MAXN, 0);
int find(int v) {
  if (v == parent[v]) return v;
  return parent[v] = find(parent[v]);
}
bool merge(int a, int b) {
  a = find(a); b = find(b);
  if(a == b) return false;
  if(rnk[a] < rnk[b]) swap(a,b);
  parent[b] = a;
  if(rnk[a] == rnk[b]) rnk[a]++;
  num[a] += num[b];
  return true;
}


// kruskal - form reference (slightly adjusted)
struct edge {
  int u, v, cost;
};
vector<edge> edgelist;
int kruskal(int n) {
  for (int i = 0; i < n; i++)
    make(i);
  ranges::sort(edgelist, {}, &edge::cost);
  int sumcost = 0;
  for (auto [u, v, cost] : edgelist)
    if (not supervised[v] and merge(u, v)) // edge e in mst
      sumcost += cost, supervised[v] = 1;
  return sumcost;
}


void solve(){
    // Code goes here ...
    cin >> N;

    int a, b, c, q;
    R(i, N)
        cin >> q;

    cin >> M;
    R(i, M){
        cin >> a >> b >> c;
        edgelist.emplace_back(a, b, c);
    }

    int res = kruskal(N + 1);
    int treesize = *ranges::max_element(num);

    if(N != treesize)
        cout << -1 << endl;
    else
        cout << res << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    /* cin >> T; */
    while(T--)
        solve();

    return 0;
}
        
